diff --git a/lib/hive/commands/web/service_installer.rb b/lib/hive/commands/web/service_installer.rb
new file mode 100644
index 000000000..4afccc9d3
--- /dev/null
+++ b/lib/hive/commands/web/service_installer.rb
@@ -0,0 +1,88 @@
+require "cgi"
+require "shellwords"
+require "hive/commands/service_installer/base"
+require "hive/commands/web"
+require "hive/paths"
+
+module Hive
+  module Commands
+    class Web
+      # Per-user autostart installer for the managed local web service. The
+      # web tier is a SEPARATE service from the daemon (R7): it inherits the
+      # platform-agnostic mechanics (drift/backup, atomic write, shim-PATH
+      # detection, enable/load orchestration) from the shared base and
+      # supplies only the web identity and rendered unit/plist bodies.
+      #
+      # The one web-specific behavior is resolving the Rails app dir into the
+      # unit (`HIVEBOX_WEB_APP_DIR`) so the managed service survives
+      # login/reboot without relying on the caller's cwd — the gem does not
+      # package the Rails app (ADR-037), so `hive web` must be told where it
+      # was provisioned.
+      class ServiceInstaller < Hive::Commands::ServiceInstaller::Base
+        def service_name
+          "hive-web"
+        end
+
+        def cli_label
+          "web"
+        end
+
+        def service_noun
+          "web service"
+        end
+
+        def unit_noun
+          "web unit"
+        end
+
+        def target_path
+          case platform
+          when :macos then File.join(@home, "Library/LaunchAgents/local.hive-web.plist")
+          when :linux then File.join(@home, ".config/systemd/user/hive-web.service")
+          end
+        end
+
+        # The Rails app dir baked into the unit. Prefer a real resolved app
+        # (env override / managed dir / sibling source checkout); fall back to
+        # the managed location when nothing exists yet so a fresh install
+        # still points `hive web` at the dir `hive setup` will populate.
+        def resolved_app_dir
+          Hive::Commands::Web.rails_app_dir || Hive::Paths.managed_web_dir
+        end
+
+        private
+
+        def render_systemd
+          template = File.read(File.expand_path("../../../../examples/systemd/hive-web.service", __dir__))
+          escaped = Shellwords.escape(resolved_binary)
+          # ExecStart= parses shell-ish quoting, so the binary stays escaped.
+          # Environment= does NOT parse shell backslash/quote escaping (unlike
+          # ExecStart=), so the app dir is interpolated RAW — a path with
+          # spaces/special characters would otherwise be corrupted (matching
+          # the daemon installer's build_path_line, which leaves Environment=
+          # values unescaped).
+          app_dir = resolved_app_dir
+          template
+            .sub(/^ExecStart=.*$/, "ExecStart=#{escaped} web --bind 127.0.0.1")
+            .sub(/^Environment=HIVEBOX_WEB_APP_DIR=.*$/, "Environment=HIVEBOX_WEB_APP_DIR=#{app_dir}")
+            .sub(/^Environment=PATH=.*$/, build_path_line)
+        end
+
+        def render_launchd
+          template = File.read(File.expand_path("../../../../examples/launchd/hive-web.plist", __dir__))
+          binary = resolved_binary
+          binary_dir = File.dirname(binary)
+          escaped_binary = CGI.escapeHTML(binary)
+          escaped_binary_dir = CGI.escapeHTML(binary_dir)
+          escaped_home = CGI.escapeHTML(@home)
+          escaped_app_dir = CGI.escapeHTML(resolved_app_dir)
+          template
+            .gsub(%r{<string>/Users/YOU/\.local/bin/hive</string>}, "<string>#{escaped_binary}</string>")
+            .gsub(%r{<string>/Users/YOU/\.local/share/hive/web</string>}, "<string>#{escaped_app_dir}</string>")
+            .gsub("/Users/YOU/Library/Logs", "#{escaped_home}/Library/Logs")
+            .gsub("/Users/YOU/.local/bin", escaped_binary_dir)
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index da8bd31af..daf9d0d30 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -2,6 +2,7 @@ require "yaml"
 require "fileutils"
 require "securerandom"
 require "pathname"
+require "ipaddr"
 require "hive/agent_profiles"
 require "hive/babysitter/interval"
 require "hive/permission_scope"
@@ -373,6 +374,15 @@ module Hive
         "bind" => "127.0.0.1",
         "port" => 4567,
         "origin" => "http://127.0.0.1:4567",
+        # Auth model for the web tier. "owner" (default) keeps the GitHub
+        # device-flow / owner-claim gate — the Docker/hivebox path, and the
+        # optional local opt-in. "loopback" means a loopback bind
+        # (127.0.0.0/8 or ::1) needs no login at all; `hive setup` / `hive
+        # web install` write this for the first-class local mode. A
+        # non-loopback bind under "loopback" is REFUSED at startup unless
+        # unsafe_public_no_auth is explicitly set (see Hive::Commands::Web).
+        "auth_mode" => "owner",
+        "unsafe_public_no_auth" => false,
         "github" => {
           "owner" => nil,
           # The shared hivebox OAuth app (device flow only — public by
@@ -691,6 +701,34 @@ module Hive
       end
     end
 
+    # The accepted `web.auth_mode` values. "owner" is the Docker/hivebox
+    # GitHub owner-claim gate; "loopback" is the local no-auth mode gated on
+    # a loopback bind (see local_web_no_auth? and web_bind_loopback?).
+    WEB_AUTH_MODES = %w[owner loopback].freeze
+
+    # True when the resolved web config opts into the local loopback
+    # no-auth policy (`web.auth_mode: loopback`). The Rails tier and the CLI
+    # both read this through the same resolved config, so request gating
+    # and startup refusal cannot drift.
+    def local_web_no_auth?(cfg)
+      cfg["auth_mode"] == "loopback"
+    end
+
+    # Conservative loopback predicate for a bind string: `localhost` and the
+    # 127.0.0.0/8 + ::1 ranges are loopback; everything else (0.0.0.0,
+    # public IPs, other hostnames) is not. A nil/blank bind is treated as
+    # loopback — the resolved default is always 127.0.0.1.
+    def web_bind_loopback?(bind)
+      host = bind.to_s.strip
+      return true if host.empty?
+      return true if host.casecmp("localhost").zero?
+
+      ip = IPAddr.new(host)
+      ip.loopback?
+    rescue IPAddr::InvalidAddressError
+      false
+    end
+
     # argv fragment for hive-launched claude: ["--model", m, "--effort", e].
     # Shared by the tmux wrapper and the headless Agent path. Semantics:
     # model "inherit"/blank omits the flag (operator's interactive default
@@ -963,6 +1001,43 @@ module Hive
       (GLOBAL_AGENT_BACKENDS & selected).freeze
     end
 
+    # The first-class local web contract persisted by `hive setup` and
+    # `hive web install` (U1): a loopback bind needs no GitHub login, so
+    # writing auth_mode=loopback (plus the canonical bind/port) here is what
+    # makes the definition-of-done "no login on loopback" true for a fresh
+    # install instead of leaving web.auth_mode at the "owner" default.
+    LOCAL_WEB_CONTRACT = {
+      "auth_mode" => "loopback",
+      "bind" => "127.0.0.1",
+      "port" => 4567
+    }.freeze
+
+    # Persist a web config block into the global config, mirroring
+    # write_global_agents!. Only the keys explicitly passed are rewritten;
+    # operator-owned sibling keys (origin, github.client_id,
+    # unsafe_public_no_auth, …) are preserved. The merged result is
+    # validated against the same defaults/loader contract as
+    # load_global_web so a bad write can never persist an invalid block.
+    def write_global_web!(web)
+      update_global_config! do |data|
+        existing = data["web"]
+        unless existing.nil? || existing.is_a?(Hash)
+          raise ConfigError, "web in #{describe_source(global_config_path)} must be a Hash; got #{existing.class}"
+        end
+
+        merged = (existing || {}).merge(web)
+        validate_web_config!({ "web" => deep_merge(global_web_defaults, merged) }, global_config_path)
+        data["web"] = merged
+        merged
+      end
+    end
+
+    # Convenience wrapper that persists the local loopback web contract
+    # (auth_mode/bind/port). Called by `hive setup` and `hive web install`.
+    def write_local_web_loopback!
+      write_global_web!(LOCAL_WEB_CONTRACT)
+    end
+
     # Shape gate shared by the loader and `prune`'s predicate so the
     # two surfaces agree on what counts as a valid registry row.
     # Without this, the loader would silently skip a corrupted entry
@@ -2277,6 +2352,20 @@ module Hive
               "web.origin in #{describe_source(source_path)} must be an http(s) URL"
       end
 
+      auth_mode = web["auth_mode"]
+      unless WEB_AUTH_MODES.include?(auth_mode)
+        raise ConfigError,
+              "web.auth_mode in #{describe_source(source_path)} must be one of " \
+              "#{WEB_AUTH_MODES.inspect}; got #{auth_mode.inspect} (#{auth_mode.class})"
+      end
+
+      unsafe = web["unsafe_public_no_auth"]
+      unless unsafe == true || unsafe == false
+        raise ConfigError,
+              "web.unsafe_public_no_auth in #{describe_source(source_path)} must be true or false; " \
+              "got #{unsafe.inspect} (#{unsafe.class})"
+      end
+
       github = web["github"]
       unless github.is_a?(Hash)
         raise ConfigError,
diff --git a/lib/hive/daemon/consistency.rb b/lib/hive/daemon/consistency.rb
new file mode 100644
index 000000000..2786479d1
--- /dev/null
+++ b/lib/hive/daemon/consistency.rb
@@ -0,0 +1,133 @@
+require "open3"
+require "shellwords"
+require "hive/commands/daemon/service_installer"
+
+module Hive
+  module Daemon
+    # Daemon binary-consistency guard (U5). Detects a daemon whose installed
+    # unit (ExecStart / ProgramArguments) or running process points at a
+    # DIFFERENT binary or version than the CLI, and exposes the result as a
+    # read-only probe for `hive daemon status --json` and the web health card.
+    #
+    # The "correct" binary is the same one `ServiceInstaller::Base` would write
+    # (brew stable symlink → HIVE_INVOKED_BIN/binary_path → PATH → source
+    # fallback), so repair (`hive daemon install --force`) rewrites to exactly
+    # the target this probe compares against.
+    class Consistency
+      def initialize(installer: nil, pid: nil, exe_reader: nil, version_probe: nil)
+        @installer = installer || Hive::Commands::Daemon::ServiceInstaller.new
+        @pid = pid
+        @exe_reader = exe_reader || method(:read_process_exe)
+        @version_probe = version_probe || method(:read_binary_version)
+      end
+
+      def expected_binary
+        @installer.resolved_binary
+      end
+
+      # The binary baked into the installed unit's ExecStart / ProgramArguments,
+      # or nil when no unit exists / no binary could be parsed.
+      def unit_binary
+        path = @installer.target_path
+        return nil if path.nil? || !File.exist?(path)
+
+        body = File.read(path)
+        case @installer.envelope_platform
+        when "linux" then systemd_unit_binary(body)
+        when "macos" then launchd_plist_binary(body)
+        end
+      rescue StandardError
+        nil
+      end
+
+      def running_binary
+        return nil if @pid.nil?
+
+        @exe_reader.call(@pid)
+      end
+
+      # Read-only probe: { binary, binary_version, unit_binary,
+      # running_binary, running_version, consistent }.
+      def probe
+        expected = expected_binary
+        ub = unit_binary
+        rb = running_binary
+        rv = rb && @version_probe.call(rb)
+
+        consistent = (ub.nil? || ub == expected) &&
+                     (rb.nil? || rb == expected) &&
+                     (rv.nil? || rv == Hive::VERSION)
+
+        {
+          "binary" => expected,
+          "binary_version" => Hive::VERSION,
+          "unit_binary" => ub,
+          "running_binary" => rb,
+          "running_version" => rv,
+          "consistent" => consistent
+        }
+      end
+
+      private
+
+      def systemd_unit_binary(body)
+        line = body.lines.map(&:strip).find { |l| l.start_with?("ExecStart=") }
+        return nil unless line
+
+        Shellwords.split(line.sub(/\AExecStart=/, "")).first
+      end
+
+      def launchd_plist_binary(body)
+        strings = body.scan(%r{<string>([^<]+)</string>}).flatten
+        strings.find { |s| s.match?(%r{/(?:hive|hv)\z}) }
+      end
+
+      # Resolve the running daemon's executable. `bin/hive` is a
+      # `#!/usr/bin/env ruby` script (and the daemon runs in-process as Ruby),
+      # so /proc/<pid>/exe resolves to the ruby interpreter, never the hive
+      # script. Read /proc/<pid>/cmdline (NUL-separated argv) instead — it
+      # carries the actual script path — and return the `hive`/`hv` script
+      # argument. Falls back to `ps -o args= -p <pid>` (same script-argument
+      # scan) when /proc is absent.
+      def read_process_exe(pid)
+        cmdline = "/proc/#{pid}/cmdline"
+        return read_exe_via_ps(pid) unless File.exist?(cmdline)
+
+        argv = File.read(cmdline).split("\0")
+        script = argv.find { |arg| hive_script_argument?(arg) }
+        script || read_exe_via_ps(pid)
+      rescue SystemCallError
+        read_exe_via_ps(pid)
+      end
+
+      def read_exe_via_ps(pid)
+        out, status = Open3.capture2("ps", "-o", "args=", "-p", pid.to_s)
+        return nil unless status.success?
+
+        script = out.strip.split(/\s+/).find { |tok| hive_script_argument?(tok) }
+        script
+      rescue StandardError
+        nil
+      end
+
+      # True when the argument is the hive launcher (bin/hive) or the hv
+      # fallback launcher. Rejects argv[0] (`ruby`) and the subcommand tokens
+      # (`daemon`, `start`), so the cmdline/ps scan selects the script path
+      # regardless of where the interpreter places it.
+      def hive_script_argument?(arg)
+        return false if arg.nil? || arg.empty?
+
+        %w[hive hv].include?(File.basename(arg))
+      end
+
+      def read_binary_version(binary)
+        out, status = Open3.capture2(binary, "--version")
+        return nil unless status.success?
+
+        out[/\d+\.\d+\.\d+/]
+      rescue StandardError
+        nil
+      end
+    end
+  end
+end
diff --git a/lib/hive/paths.rb b/lib/hive/paths.rb
index 752a5c7dc..e2d3be254 100644
--- a/lib/hive/paths.rb
+++ b/lib/hive/paths.rb
@@ -20,6 +20,13 @@ module Hive
       hive_home_override || File.join(base_home("XDG_CACHE_HOME", ".cache"), "hive")
     end
 
+    # Where `hive setup` provisions the web bundle for the first-class local
+    # mode (the gem does not package the Rails app — ADR-037). Lives under
+    # XDG data so it survives login/reboot and stays out of the git repo.
+    def managed_web_dir
+      File.join(data_home, "web")
+    end
+
     def task_counter_path
       File.join(state_home, "task-counter.yml")
     end
diff --git a/packaging/verify-release.sh b/packaging/verify-release.sh
index a66153eaa..bc45068c1 100755
--- a/packaging/verify-release.sh
+++ b/packaging/verify-release.sh
@@ -544,7 +544,72 @@ else
   log "step: daemon install — SKIPPED (pinned release predates the subcommand)"
 fi
 
-# ─── 5. uninstall ────────────────────────────────────────────────────
+# ─── 5. local web service + hive setup --json ─────────────────────────
+
+# U8 acceptance surface: the local (non-Docker) web install/run mode is
+# shipped behind two commands — `hive web status --json` (a fast,
+# network-free read) and `hive setup --json` (the full provisioning
+# orchestration, which in a CI sandbox legitimately lacks the external
+# agent CLIs / network and therefore must still emit its typed envelope
+# rather than crash). Both are feature-detected so this script stays
+# green against pre-feature releases.
+
+step "hive web status --json (local web service surface)"
+set +e
+"$XDG_BIN_HOME/hive" web status --json >"$PREFIX/web-status.json" 2>"$PREFIX/web-status.err"
+WEB_STATUS_RC=$?
+set -e
+WEB_SCHEMA="$(jq -r '.schema // empty' "$PREFIX/web-status.json" 2>/dev/null || true)"
+if [[ "$WEB_SCHEMA" == "hive-web-status" ]]; then
+  ok "web status envelope schema=hive-web-status (rc=$WEB_STATUS_RC)"
+  WEB_BIND="$(jq -r '.bind // empty' "$PREFIX/web-status.json" 2>/dev/null || true)"
+  WEB_PORT="$(jq -r '.port // empty' "$PREFIX/web-status.json" 2>/dev/null || true)"
+  if [[ "$WEB_BIND" == "127.0.0.1" ]]; then ok "web status bind=127.0.0.1"
+  else fail "web status bind='$WEB_BIND', want 127.0.0.1"; fi
+  if [[ "$WEB_PORT" == "4567" ]]; then ok "web status port=4567"
+  else fail "web status port='$WEB_PORT', want 4567"; fi
+else
+  log "web status — SKIPPED (release predates the `hive web` subcommand)"
+fi
+
+# Feature-detect `hive setup` by asking Thor for its help: the command
+# exists when `--help` exits 0 (a missing command exits non-zero).
+set +e
+"$XDG_BIN_HOME/hive" setup --help >/dev/null 2>&1
+SETUP_HELP_RC=$?
+set -e
+if [[ "$SETUP_HELP_RC" -eq 0 ]]; then
+  step "hive setup --json (walk provisioning; external CLIs/network may be absent in CI)"
+  # `hive setup` runs every step before reporting, so even a partial
+  # bring-up must emit the single hive-setup envelope (ok=false + per-step
+  # detail) on stdout and then exit non-zero. Run from the scratch project
+  # (already registered) so enrollment exercises the enable path, pipe empty
+  # stdin for the non-interactive backend defaults, and bound the whole walk
+  # against a hung network-bound dep (npm install / web-bundle git clone).
+  set +e
+  ( cd "$PROJECT" \
+      && timeout 240 "$XDG_BIN_HOME/hive" setup --json </dev/null \
+           >"$PREFIX/setup.json" 2>"$PREFIX/setup.err" )
+  SETUP_RC=$?
+  set -e
+  SETUP_SCHEMA="$(jq -r '.schema // empty' "$PREFIX/setup.json" 2>/dev/null || true)"
+  if [[ "$SETUP_SCHEMA" == "hive-setup" ]]; then
+    SETUP_OK="$(jq -r '.ok | tostring' "$PREFIX/setup.json" 2>/dev/null || true)"
+    ok "setup envelope schema=hive-setup ok=$SETUP_OK (rc=$SETUP_RC)"
+    SETUP_WEB_URL="$(jq -r '.web_url // empty' "$PREFIX/setup.json" 2>/dev/null || true)"
+    if [[ -n "$SETUP_WEB_URL" ]]; then ok "setup envelope carries web_url=$SETUP_WEB_URL"
+    else fail "setup envelope missing web_url"; fi
+  elif [[ "$SETUP_RC" -eq 124 ]]; then
+    log "setup --json timed out (network-bound deps in CI); envelope walk skipped"
+  else
+    cat "$PREFIX/setup.err" >&2 2>/dev/null || true
+    fail "setup did not emit a hive-setup envelope (rc=$SETUP_RC)"
+  fi
+else
+  log "step: hive setup — SKIPPED (pinned release predates the command)"
+fi
+
+# ─── 6. uninstall ────────────────────────────────────────────────────
 
 if [[ $RUN_UNINSTALL -eq 1 ]]; then
   step "hive uninstall"
@@ -588,7 +653,7 @@ if [[ $RUN_UNINSTALL -eq 1 ]]; then
   fi
 fi
 
-# ─── 6. leak detection ───────────────────────────────────────────────
+# ─── 7. leak detection ───────────────────────────────────────────────
 
 # Verify that nothing the install/test sequence wrote leaked outside
 # the prefix. We anchor on the real (un-mocked) user's HOME — but
diff --git a/test/integration/daemon_status_consistency_test.rb b/test/integration/daemon_status_consistency_test.rb
new file mode 100644
index 000000000..7ba308d26
--- /dev/null
+++ b/test/integration/daemon_status_consistency_test.rb
@@ -0,0 +1,46 @@
+require "test_helper"
+require "json"
+require "open3"
+require "tmpdir"
+
+# Integration test for the U5 binary-consistency fields on
+# `hive daemon status --json`. Uses real bin/hive subprocesses against an
+# isolated HIVE_HOME/HOME so the unit-file probe never touches the real user.
+class DaemonStatusConsistencyTest < Minitest::Test
+  include HiveTestHelper
+
+  REPO_ROOT = File.expand_path("../..", __dir__)
+  HIVE_BIN = File.join(REPO_ROOT, "bin", "hive")
+
+  def status_json(env)
+    out, _err, = Open3.capture3(env, "ruby", "-Ilib", HIVE_BIN, "daemon", "status", "--json")
+    JSON.parse(out)
+  end
+
+  def test_status_json_includes_consistency_fields_when_consistent
+    Dir.mktmpdir("hive-consistency") do |home|
+      env = ENV.to_h.merge("HIVE_HOME" => home, "HOME" => home)
+      doc = status_json(env)
+
+      assert_kind_of String, doc["binary"], "binary must be the resolved CLI binary"
+      assert_equal Hive::VERSION, doc["binary_version"]
+      assert_equal true, doc["consistent"], "no unit + no running daemon = consistent"
+    end
+  end
+
+  def test_drifted_unit_surfaces_consistent_false
+    Dir.mktmpdir("hive-consistency") do |home|
+      env = ENV.to_h.merge("HIVE_HOME" => home, "HOME" => home)
+      unit = File.join(home, ".config", "systemd", "user", "hive-daemon.service")
+      FileUtils.mkdir_p(File.dirname(unit))
+      # A stale Apache-Hive / different-binary ExecStart must drift.
+      File.write(unit, "ExecStart=/usr/bin/hive daemon start\n")
+
+      doc = status_json(env)
+      assert_equal false, doc["consistent"],
+                   "a unit whose ExecStart binary differs from the resolved CLI binary must be inconsistent"
+      refute_equal "/usr/bin/hive", doc["binary"],
+                   "the resolved binary must NOT be the stale /usr/bin/hive (Apache Hive shadowing)"
+    end
+  end
+end
diff --git a/test/integration/setup_test.rb b/test/integration/setup_test.rb
new file mode 100644
index 000000000..959a98ff9
--- /dev/null
+++ b/test/integration/setup_test.rb
@@ -0,0 +1,70 @@
+require "test_helper"
+require "hive/commands/setup/deps"
+
+# Integration test for `hive setup`'s dependency checker against REAL
+# subprocesses: stub the external agent CLIs on PATH and assert they are
+# probed (never installed or authenticated) and that a real `hive setup`'s
+# deps step reports them accurately. The full provisioning pipeline (web
+# bundle fetch + daemon/web service) is exercised by the e2e scenario (U8);
+# this test pins the diagnose-only contract cheaply.
+class SetupIntegrationTest < Minitest::Test
+  include HiveTestHelper
+
+  def stub_bin(dir, name, body)
+    path = File.join(dir, name)
+    File.write(path, body)
+    FileUtils.chmod(0755, path)
+    path
+  end
+
+  def with_stubbed_path
+    with_tmp_dir do |bin|
+      stub_bin(bin, "claude", "#!/bin/sh\necho '2.1.118 (Claude Code)'\n")
+      stub_bin(bin, "codex", "#!/bin/sh\necho '0.125.0'\n")
+      stub_bin(bin, "gh", "#!/bin/sh\nif [ \"$1\" = \"auth\" ]; then exit 0; fi; echo 'gh version 2.66.1'\n")
+      stub_bin(bin, "node", "#!/bin/sh\necho 'v18.20.4'\n")
+      stub_bin(bin, "npm", "#!/bin/sh\necho '10.8.2'\n")
+      stub_bin(bin, "sqlite3", "#!/bin/sh\necho '3.45.3'\n")
+      stub_bin(bin, "tmux", "#!/bin/sh\necho 'tmux 3.5a'\n")
+      with_env("PATH" => [ bin, ENV.fetch("PATH", "") ].join(File::PATH_SEPARATOR)) do
+        yield bin
+      end
+    end
+  end
+
+  def test_deps_probe_real_stub_binaries_without_modifying_them
+    with_stubbed_path do |bin|
+      before = Dir.children(bin).to_h { |name| [ name, File.read(File.join(bin, name)) ] }
+
+      results = Hive::Commands::Setup::Deps.new.check
+      by_name = results.to_h { |r| [ r.name, r ] }
+
+      assert by_name["claude"].ok, "stubbed claude 2.1.118 must satisfy the minimum"
+      assert by_name["codex"].ok
+      assert by_name["gh"].ok, "gh auth status returning 0 must count as authenticated"
+      assert by_name["node/npm"].ok
+      assert by_name["sqlite3"].ok
+      assert by_name["tmux"].ok
+
+      # git / ruby come from the real PATH (this host has both).
+      assert by_name["git"].ok, "real git must be detected on PATH"
+      assert by_name["ruby"].ok, "the test host's ruby 3.4 must satisfy the gate"
+
+      after = Dir.children(bin).to_h { |name| [ name, File.read(File.join(bin, name)) ] }
+      assert_equal before, after,
+                   "the dependency check must be read-only — external agent CLIs are never modified"
+    end
+  end
+
+  def test_unauthenticated_gh_is_reported_blocked
+    with_tmp_dir do |bin|
+      stub_bin(bin, "gh", "#!/bin/sh\nif [ \"$1\" = \"auth\" ]; then exit 1; fi; echo 'gh version 2.66.1'\n")
+      with_env("PATH" => [ bin, ENV.fetch("PATH", "") ].join(File::PATH_SEPARATOR)) do
+        gh = Hive::Commands::Setup::Deps.new.check.find { |r| r.name == "gh" }
+        refute gh.ok
+        assert gh.blocked, "an unauthenticated gh is blocked, not fixed by setup"
+        assert_equal "gh auth login", gh.fix
+      end
+    end
+  end
+end
diff --git a/test/unit/cli_test.rb b/test/unit/cli_test.rb
index dafa1c291..ab987c98a 100644
--- a/test/unit/cli_test.rb
+++ b/test/unit/cli_test.rb
@@ -519,7 +519,9 @@ class HiveCliTest < Minitest::Test
     require "hive/commands/web"
     captured = []
     recorder = Class.new do
-      define_method(:initialize) { |bind:, port:| captured << { bind: bind, port: port } }
+      define_method(:initialize) do |subcommand = nil, bind:, port:, force:, json:|
+        captured << { subcommand: subcommand, bind: bind, port: port, force: force, json: json }
+      end
       define_method(:call) { captured << :called }
     end
 
@@ -533,7 +535,7 @@ class HiveCliTest < Minitest::Test
       Hive::Commands.const_set(:Web, original)
     end
 
-    assert_equal({ bind: "0.0.0.0", port: 9123 }, captured.first,
+    assert_equal({ subcommand: nil, bind: "0.0.0.0", port: 9123, force: false, json: false }, captured.first,
                  "the --bind/--port flags must reach the web command")
     assert_equal :called, captured.last, "hive web must invoke the web command's #call"
   end
diff --git a/test/unit/commands/setup/deps_test.rb b/test/unit/commands/setup/deps_test.rb
new file mode 100644
index 000000000..59e28f96d
--- /dev/null
+++ b/test/unit/commands/setup/deps_test.rb
@@ -0,0 +1,113 @@
+require "test_helper"
+require "hive/commands/setup/deps"
+
+class SetupDepsTest < Minitest::Test
+  include HiveTestHelper
+
+  # A fake `runner` that answers per-argv. `script` is a Hash of
+  # [argv.join(" ")] => [stdout, ok].
+  def fake_runner(script)
+    ->(argv) { script.fetch(argv.join(" ")) { [ "", true ] } }
+  end
+
+  def build(script)
+    Hive::Commands::Setup::Deps.new(runner: fake_runner(script))
+  end
+
+  def result_for(results, name)
+    results.find { |r| r.name == name }
+  end
+
+  def test_all_present_reports_every_dependency_ok
+    script = {
+      "ruby --version" => [ "ruby 3.4.10 (2026-06-30)", true ],
+      "git --version" => [ "git version 2.39.5", true ],
+      "tmux -V" => [ "tmux 3.5a", true ],
+      "gh --version" => [ "gh version 2.66.1", true ],
+      "gh auth status" => [ "", true ],
+      "claude --version" => [ "2.1.118 (Claude Code)", true ],
+      "codex --version" => [ "0.125.0", true ],
+      "node --version" => [ "v18.20.4", true ],
+      "npm --version" => [ "10.8.2", true ],
+      "sqlite3 --version" => [ "3.45.3 2024-04-15", true ]
+    }
+    results = build(script).check
+    assert_equal 8, results.size
+    assert results.all?(&:ok), "every dep present should be ok: #{results.reject(&:ok).map(&:name)}"
+  end
+
+  def test_ruby_3_4_is_exact_not_a_floor
+    script = { "ruby --version" => [ "ruby 3.5.0", true ] }
+    r = result_for(build(script).check, "ruby")
+    refute r.ok
+    assert_match(/3\.4/, r.message)
+  end
+
+  def test_missing_gh_is_blocked_with_install_and_login_fix
+    script = { "gh --version" => [ "", false ] }
+    r = result_for(build(script).check, "gh")
+    refute r.ok
+    assert r.blocked, "gh is an external CLI — missing must be blocked, not silently installed"
+    assert_match(/brew install gh/, r.fix)
+    assert_match(/gh auth login/, r.fix)
+  end
+
+  def test_installed_but_unauthenticated_gh_is_blocked
+    script = { "gh --version" => [ "gh version 2.66.1", true ], "gh auth status" => [ "", false ] }
+    r = result_for(build(script).check, "gh")
+    refute r.ok
+    assert r.blocked
+    assert_equal "gh auth login", r.fix
+  end
+
+  def test_claude_below_minimum_is_blocked
+    script = { "claude --version" => [ "2.1.100", true ] }
+    r = result_for(build(script).check, "claude")
+    refute r.ok
+    assert r.blocked
+    assert_match(/brew upgrade claude/, r.fix)
+  end
+
+  def test_codex_missing_is_blocked_with_login_fix
+    script = { "codex --version" => [ "", false ] }
+    r = result_for(build(script).check, "codex")
+    refute r.ok
+    assert r.blocked
+    assert_match(/brew install codex/, r.fix)
+    assert_match(/codex login/, r.fix)
+  end
+
+  def test_missing_node_blocks_node_npm_check
+    script = { "node --version" => [ "", false ], "npm --version" => [ "10.8.2", true ] }
+    r = result_for(build(script).check, "node/npm")
+    refute r.ok
+    refute r.blocked, "node is not an external agent CLI"
+  end
+
+  def test_blocked_names_returns_only_external_clis
+    script = {
+      "gh --version" => [ "", false ],
+      "claude --version" => [ "", false ],
+      "codex --version" => [ "", false ],
+      "git --version" => [ "git version 2.39.5", true ],
+      "tmux -V" => [ "tmux 3.5a", true ],
+      "ruby --version" => [ "ruby 3.4.10", true ],
+      "node --version" => [ "v18.20.4", true ],
+      "npm --version" => [ "10.8.2", true ],
+      "sqlite3 --version" => [ "3.45.3", true ]
+    }
+    assert_equal %w[claude codex gh], build(script).blocked_names.sort
+  end
+
+  def test_to_h_is_schema_shaped
+    r = Hive::Commands::Setup::Deps::Result.new(
+      name: "ruby", ok: true, blocked: false, found: "3.4.10", required: "3.4.x",
+      message: "ok", fix: nil
+    )
+    assert_equal(
+      { "name" => "ruby", "ok" => true, "blocked" => false, "found" => "3.4.10",
+        "required" => "3.4.x", "message" => "ok", "fix" => nil },
+      r.to_h
+    )
+  end
+end
